import threading
from typing import Optional

from cpl_core.mailing import EMailClientABC, EMail


class MailThread(threading.Thread):

    def __init__(self, mailer: EMailClientABC):
        threading.Thread.__init__(self, daemon=True)

        self._mailer = mailer
        self._mail: Optional[EMail] = None

    def send_mail(self, mail: EMail):
        self._mail = mail
        self.start()

    def run(self) -> None:
        if self._mailer is None:
            return

        self._mailer.send_mail(self._mail)
